#if ! defined(__PNNFAST_H)
#define __PNNFAST_H

#include "owntypes.h"
#include "cb.h"


/*----------------------- Type definitions --------------------------*/


typedef struct { llong  VectorDist;
                 int    Vector;
                 YESNO  Recalculate;
               } NEARESTTYPE;


typedef struct { int*    codesum;    /* Element sums of the code vectors */
                 int*    codeorder;  /* Order for code vectors */
                 int*    mynumber;   /*MPSindex of trainingvector*/
               } DATA;


/*--------------------------------------------------------------------*/

void PNNClass(TRAININGSET*  TS,
             CODEBOOK*      CB,
             int            QuietLevel,
             long           watch);

/*--------------------------------------------------------------------*/

void PNNFast(TRAININGSET*   TS,
             CODEBOOK*      CB,
             PARTITIONING*  P,
             int            FinalSize,
             int            QuietLevel,
             long           watch,
			 int			Pds,
			 int			Mps,
             int            Lazy);

/*--------------------------------------------------------------------*/

double PNNGOp1(TRAININGSET*   TS,
               CODEBOOK*      CB,
               PARTITIONING*  P,
               int            FinalSize,
               int            QuietLevel,
               long           watch,
		       int  		  Pds,
			   int			  Mps,
               int            Lazy);


/*--------------------------------------------------------------------*/

double PNNGOp2(TRAININGSET*   TS,
               CODEBOOK*      CB,
               PARTITIONING*  P,
               int            FinalSize,
               int            QuietLevel,
               long           watch,
		       int  		  Pds,
			   int			  Mps,
               int            Lazy);

/*--------------------------------------------------------------------*/

double PNNGOp3(TRAININGSET*	    TS,
			   CODEBOOK*		CB,
			   PARTITIONING*	P,
               int              FinalSize,
               int              Quiet,
               long             watch,
               int              Pds,
               int              Mps,
               int              Lazy);


/*--------------------------------------------------------------------*/

double PNNGBb2(TRAININGSET*	    TS,
			   CODEBOOK*		CB,
			   PARTITIONING*	P,
               int              FinalSize,
               int              StepSize,
               int              Quiet,
               long             watch,
               int              Pds,
               int              Mps,
               int              Lazy);
               
/*--------------------------------------------------------------------*/

double PNNGBb3(TRAININGSET*	    TS,
			   CODEBOOK*		CB,
			   PARTITIONING*	P,
               int              FinalSize,
               int              StepSize,
               int              Quiet,
               long             watch,
               int              Pds,
               int              Mps,
               int              Lazy);
               
/*--------------------------------------------------------------------*/

double PNNGBb4(TRAININGSET*   TS,
               CODEBOOK*      CB,
               PARTITIONING*  P,
               int            FinalSize,
               int            Quiet,
               long           watch,
               int            Pds,
               int            Mps,
               int            Lazy); 

/*--------------------------------------------------------------------*/

double PNNGBb4_2(TRAININGSET*   TS,
               CODEBOOK*      CB,
               PARTITIONING*  P,
               int            FinalSize,
               int            Quiet,
               long           watch,
               int            Pds,
               int            Mps,
               int            Lazy); 
/*--------------------------------------------------------------------*/

double PNNGBb5(TRAININGSET*   TS,
               CODEBOOK*      CB,
               PARTITIONING*  P,
               int            FinalSize,
               int            Quiet,
               long           watch,
               int            Pds,
               int            Mps,
               int            Lazy); 

/*--------------------------------------------------------------------*/

double PNNGBb5_2(TRAININGSET*   TS,
               CODEBOOK*      CB,
               PARTITIONING*  P,
               int            FinalSize,
               int            Quiet,
               long           watch,
               int            Pds,
               int            Mps,
               int            Lazy); 
                                                   
/*--------------------------------------------------------------------*/

void CalculateAllDistances(CODEBOOK* CB,
                           DATA*     D,
                           NEARESTTYPE NN[],
                           int Quiet,
                           long watch,
                           int Pds,
                           int Mps);
void FindMergedPair(CODEBOOK* CB, DATA* D, NEARESTTYPE NN[], int* a, int* b,
                           int Pds, int Mps);
void MergeVectors(TRAININGSET*   TS,
                  CODEBOOK*      CB,
                  PARTITIONING*  P,
                  NEARESTTYPE    NN[],
                  int            a,
                  int            b);
void RecalculateDistances(CODEBOOK* CB, NEARESTTYPE NN[], int aex,
								 int Quiet, int Pds, int Lazy);
void RemoveEmptyPartitions(TRAININGSET*  TS,
                           CODEBOOK*     CB,
                           PARTITIONING* P,
                           int           FinalSize);
void CreateDataStructures(CODEBOOK* CB, DATA* D, NEARESTTYPE** NN, int Mps);
void InitializeData(CODEBOOK* CB, DATA* D, NEARESTTYPE NN[], int Mps);
void FreeDataStructures(DATA* D, NEARESTTYPE NN[], int Mps);


#endif /* __PNNFAST_H */
